#####################################################################################
# Copyright 2011 Normation SAS
#####################################################################################
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, Version 3.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#####################################################################################

bundle agent root_apache_webdav_check {

	vars:

			# I WANT to use this but there is no crypt support... yet
			# "dav_password" string => hash("rudder","crypt");

			"dav_user[1]" string => "rudder";
			"dav_password[1]" string => "PoBZbSkW/8bcE";

			"iterator" slist => getindices("dav_user");

		debian::

			"webdav_check_wwwgroup" string => "www-data";

		!debian::

			"webdav_check_wwwgroup" string => "www";

	files:

			"$(g.rudder_base)/etc/htpasswd-webdav"
				create => "true",
				edit_line => insert_lines("$(dav_user[$(iterator)]):$(dav_password[$(iterator)])"),
				edit_defaults => empty,
				perms => mog("640", "root", "$(webdav_check_wwwgroup)"),
        			classes => kept_if_else("rudder_apache_davpassword_ok", "rudder_apache_davpassword_changed", "rudder_apache_davpassword_failed"),
			        comment => "Verifying the Rudder WebDAV user and password";

	reports:

		linux::

			"@@DistributePolicy@@result_success@@&TRACKINGKEY&@@reports@@None@@$(g.execRun)##$(g.uuid)@#The Rudder WebDAV user and password are OK"
				ifvarclass => "rudder_apache_davpassword_ok.!rudder_apache_davpassword_changed.!rudder_apache_davpassword_failed";

			"@@DistributePolicy@@result_repaired@@&TRACKINGKEY&@@reports@@None@@$(g.execRun)##$(g.uuid)@#The Rudder WebDAV user and password were updated"
				ifvarclass => "rudder_apache_davpassword_changed.!rudder_apache_davpassword_failed";

			"@@DistributePolicy@@result_error@@&TRACKINGKEY&@@reports@@None@@$(g.execRun)##$(g.uuid)@#The Rudder WebDAV user and password could not be updated"
				ifvarclass => "rudder_apache_davpassword_failed";

}
